/*
	http://www.theskinsfactory.com
	info@theskinsfactory.com
	Frostbite WMP skin
*/


/*
	Copyright  2003. The Skins Factory, Inc. All Rights Reserved.
	This code may not be reproduced in whole or in part without express permission of The Skins Factory, Inc.
*/

function onLoadPreview(){
	if(player){}
	view.width = 0;
	view.height = 0;
	view.backgroundImage = "";
	theme.currentViewID = "controlView";
}

function onLoadSkin()
{
	theme.savePreference("exitView", "false");

    if ("true"==theme.loadPreference("plViewer"))
	{
		theme.openView( 'plView' );
	}

	if ("true"==theme.loadPreference("eqViewer"))
	{
		theme.openView( 'eqView' );
	}

	if ("true"==theme.loadPreference("visViewer"))
	{
		theme.openView( 'visView' );
	}

	if ("true"==theme.loadPreference("infoViewer"))
	{
		theme.openView( 'infoView' );
	}

	theme.openView('mainView');

	checkControlPlayerState();
}

function checkViewStatus()
{
	if("true"==theme.loadPreference("remoteCallPl"))
	{
		toggleView('plView','plViewer')
		theme.savePreference("remoteCallPl", "false");
	}
	if("true"==theme.loadPreference("remoteCallEq"))
	{
		toggleView('eqView','eqViewer')
		theme.savePreference("remoteCallEq", "false");
	}
	if("true"==theme.loadPreference("remoteCallVis"))
	{
		toggleView('visView','visViewer')
		theme.savePreference("remoteCallVis", "false");
	}

	if("true"==theme.loadPreference("minimizeView"))
	{
		view.minimize();
		theme.savePreference("minimizeView", "false");
	}
	if("true"==theme.loadPreference("exitView"))
	{
		
		view.close();
	}
}

function onCloseSkin()
{
	theme.savePreference("exitView", "false");
}

function checkControlPlayerState(){

	if (player){
		switch (player.playState){

			case 2:
			case 3: 	//playing

				if(("false"==theme.loadPreference("vidViewer"))&&player.currentMedia.ImageSourceWidth>0){
					theme.openView('videoView');
				/*	if("true"==theme.loadPreference("visViewer")){
					    theme.savePreference("visViewer", "false");
						theme.closeView( "visView" );
					} 
					break*/
				}
				break;
			}
		}
}

// main mode

function mainStartUp(){
	volume.value = player.settings.volume;
	loadMainPrefs();
	theme.savePreference("vidViewer", "false");
	checkPlayerState();
	updateMetadata('status');
}

function checkPlayerState(){

	if (player){
		switch (player.playState){

			case 2:
			case 3: 	//playing
				snowflakeAnim.backgroundImage = "m_snowflake_anim.gif";
			/*	if(("false"==theme.loadPreference("vidViewer"))&&player.currentMedia.ImageSourceWidth>0){
					theme.openView('videoView');
					if("true"==theme.loadPreference("visViewer")){
					    theme.savePreference("visViewer", "false");
						theme.closeView( "visView" );
					}
					break
				} */
				break;
			}
		}


	if (!player.controls.isAvailable("Stop")) {
		snowflakeAnim.backgroundImage = "m_snowflake.png";
	}

}

// metadata

function updateMetadata(type){
	if("status"==type){
		if(player.openState!=13) return;

		var metaAuthor = player.currentMedia.getItemInfo("author");

		if (metaAuthor != "") {
			metaAuthor += " - ";
		}

		metadata.value = player.status;

		if (metadata.value != "") {
			metadata.value += " - ";
		}

		metadata.value += metaAuthor;
	}else if("playlist"==type){
		if(player.currentPlaylist.count==0) return;

		var metaAuthor = player.currentMedia.getItemInfo("author");

		if (metaAuthor != "") {
			metaAuthor += " - ";
		}

		if(player.openState!=13){
			metadata.value = metaAuthor;
		}
	}else{
		metadata.value = player.status;
		metadata.scrolling = (metadata.textWidth>metadata.width);
		return;
	}

	metadata.value += player.currentmedia.name;
	metadata.scrolling = (metadata.textWidth>metadata.width);

}

var seekStatus = true;

function drawSeekDigits( seconds )
{
	if(player.currentPlaylist.count==0) return;

	if( !seekStatus )
    {
        seconds = player.currentMedia.duration - seconds;
    }

	frame = 9
    seconds = seconds - seconds % 1;

    time4.left = -( seconds % 10 ) * frame;

    seconds = seconds - ( seconds % 10);
    time3.left = -( ( seconds % 60 ) / 10 ) * frame;

    seconds = seconds - ( seconds % 60 );
    seconds = seconds / 60;
    time2.left = -( seconds % 10 ) * frame;

    seconds = seconds - ( seconds % 10 );
    time1.left = -( seconds / 10 ) * frame;
}

function SetTimeShowState()
{
    seekStatus = !seekStatus;

    if( seekStatus )
    {
        timeDash.visible = false;;
    }
    else
    {
        timeDash.visible = true;
    }

	seconds = seek.value;

	drawSeekDigits( seconds );
}


// button and hotkey definitions

// open file
function openFile()
{
	var media = theme.openDialog('FILE_OPEN','FILES_ALLMEDIA');
	if(media)
	{
		player.URL = media;
		player.controls.play();
	}
}

function viewHotKeys()
{
	switch(event.keycode)
	{
		case 122:
		case 90:
			player.controls.previous();
			break;
		case 120:
		case 88:
			player.controls.play();
			break;
		case 99:
		case 67:
			player.controls.pause();
			break;
		case 118:
		case 86:
			player.controls.stop();
			break;
		case 98:
		case 66:
			player.controls.next();
			break;
		case 108:
		case 76:
			openFile();
			break;
	}
}

function viewResizer(event)
{
	switch(event.keycode)
	{
		case 37:
			view.width-=20;
			break;
		case 38:
			view.height-=20
			break;
		case 39:
			view.width+=20;
			break;
		case 40:
			view.height+=20;
			break;
	}
}

function updateToolTip(id,button,tip)
{
	if("true"==theme.loadPreference( id ))
	{
		eval( button +".upToolTip = locHide" + tip + ".toolTip" );
	}
	else
	{
		eval( button +".upToolTip = locShow" + tip + ".toolTip" );
	}
}

function updateSeekToolTip()
{
	if(player.openState!=13) return;

	var seekHours = Math.floor((seek.value / 3600));
	if (seekHours < 10) seekHours = "0" + seekHours;

	var seekMinutes = Math.floor((seek.value - (seekHours*3600))/60);
	if (seekMinutes < 10) seekMinutes = "0" + seekMinutes;

	var seekSeconds = Math.floor((seek.value - (seekMinutes*60) - (seekHours*3600)));
	if (seekSeconds < 10) seekSeconds = "0" + seekSeconds;

	var seekString;

	if (seekHours==00)
	{
		seekString = "";
	}
	else
	{
		seekString = seekHours + ":";
	}

	seekString += seekMinutes + ":" + seekSeconds;

	seek.toolTip = seekString;
	seek.toolTip += " / ";
	seek.toolTip += player.currentMedia.DurationString;

}

function updateVolToolTip(id)
{
	vol = "";
	vol += player.settings.volume;
	eval(id + ".toolTip = vol" );
}

function updateShuffRep()
{
	if(player.settings.getMode('shuffle'))
	{
		shuffleButton.down = true;
	}else{
		shuffleButton.down = false;
	}

	if(player.settings.getMode('loop'))
	{
		repeatButton.down = true;
	}else{
		repeatButton.down = false;
	}
}

//

function volKey(event)
{
	switch(event.keycode)
	{
		case 39:
		case 38:
			if(player.settings.volume < 95)
			{
				player.settings.volume+=5;
			}else{
				player.settings.volume = 100;
			}
			break;
		case 37:
		case 40:
			if(player.settings.volume > 5)
			{
				player.settings.volume-=5;
			}else{
				player.settings.volume = 0;
			}
			break;
	}
	player.settings.mute = false;
}

function seekKey(event)
{
	if(player.openState!=13) return;
	switch(event.keycode)
	{
		case 37:
		case 40:
			if(player.controls.currentPosition > 10)
			{
				player.controls.currentPosition-=10;
			}else{
				player.controls.currentPosition = 0;
			}
			break;
		case 39:
		case 38:
			if(player.controls.currentPosition < player.currentMedia.duration)
			{
				player.controls.currentPosition+=10;
			}else{
				player.controls.currentPosition = player.currentMedia.duration;
			}
			break;
	}
}

// view toggle 

function toggleView(name,id)
{
	if("true"==theme.loadPreference(id))
	{
	    theme.savePreference(id, "false");
		theme.closeView( name );
	}else{
		theme.openView( name );
	}
}

function closeView(id)
{
	theme.savePreference(id, "false");
	if( id=="vidViewer" )
	{
		player.controls.stop();
		//theme.savePreference("vidCheck", "false");
		theme.savePreference("vidViewer", "false");
	}
	view.close();
}

function autoSizeView(width,height)
{
    var viewSize = theme.loadPreference( width );

    if( "--" != viewSize )
    {
        view.width = viewSize;
    }else{
		view.width = view.minWidth;
	}

    viewSize = theme.loadpreference( height );

    if( "--" != viewSize )
    {
        view.height = viewSize;
    }else{
		view.height = view.minHeight;
	}
}

function saveViewSize(width,height)
{
	theme.savepreference( width , view.width );
    theme.savepreference( height , view.height );
}



// preferences

function loadMainPrefs(){

	theme.savePreference("exitView", "false");

	var _seekStatus = theme.loadPreference('seekStatus');

	if (_seekStatus != '--')
	{
		seekStatus = (_seekStatus.toLowerCase() == 'true') ? false : true;
	} else {
		seekStatus = true;
	}

	SetTimeShowState();
}

function saveMainPrefs() {
	theme.savePreference("exitView", "true");
}

function mainShutDown(){
	saveMainPrefs();
}

// playlist
function loadPlPrefs()
{
	theme.savePreference( 'plViewer', "true" );

	autoSizeView('plWidth','plHeight');

	var index = 0;

	playlist1.setColumnResizeMode( index++, "AutosizeData" );
    playlist1.setColumnResizeMode( index++, "Stretches" );
    playlist1.setColumnResizeMode( index++, "AutosizeHeader" );
    playlist1.setColumnResizeMode( index++, "AutosizeHeader" );
    playlist1.setColumnResizeMode( index++, "AutosizeHeader" );
	playlist1.setColumnResizeMode( index++, "AutosizeHeader" );

	checkPlViewSize()
}

function savePlPrefs(){
	saveViewSize('plWidth','plHeight');
}


function checkPlViewSize(){
	plBotTile.width = (view.width / 2) + 48;
}

// equalizer

function eqKey(event,level){
	switch(event.keyCode){
		case 38: // up
		case 39:
			eval("eq.gainLevel" + level + "++");
			break;
		case 40: // down
		case 37:
			eval("eq.gainLevel" + level + "--");
			break;
	}

}

// visualizations
function loadVisPrefs(){
	theme.savePreference( 'visViewer', "true" );
	visEffects.currentEffectType = mediacenter.effectType;
	visEffects.currentPreset = mediacenter.effectPreset;

	autoSizeView('visWidth','visHeight');

	checkVisualsPlayerState();
	checkVisViewSize();
}

function saveVisPrefs(){
	mediacenter.effectType = visEffects.currentEffectType;
	mediacenter.effectPreset = visEffects.currentPreset;
	saveViewSize('visWidth','visHeight');
}

function checkVisualsPlayerState(){

	if (player){
		switch (player.playState){
			case 2:
			case 3: 	//playing
				//visMask.visible = true;
				displayVisText()
				if(player.currentMedia.ImageSourceWidth>0){
					theme.savePreference('visViewer', "false");
					view.close();
				}
				break;

			}
		}

	if (!player.controls.isAvailable("Stop")) {
		//visMask.visible = false;
	}
}

function displayVisText(){
	visEffectsSub.visible = true;
	//visEffectsText.value = visEffects.currentEffectTitle + ": " + visEffects.currentPresetTitle;
	visView.timerInterval = 6000
}

function hideVisText(){
	visEffectsSub.visible = false;
	visView.timerInterval = 0
}

function checkVisViewSize(){
	visBotTile.width = (view.width / 2) + 48;
}

// video settings

function loadVidPrefs(){
	theme.savePreference( 'vidViewer', "true" );

	var _drawerStatus = theme.loadPreference('drawerStatus');

	if (_drawerStatus != '--') {
		drawerStatus = (_drawerStatus.toLowerCase() == 'true') ? false : true;
	} else {
		drawerStatus = true;
	}

	checkSnapStatus();
	checkVideoPlayerState();
	updateZoomToolTip();
	toggleVidDrawer();
	checkVidViewSize();
}

function saveVidPrefs(){
	theme.savePreference('drawerStatus',drawerStatus);
}

function loadVidSize(){
    var vidSizer = theme.loadPreference( "videoWidth" );

    if( "--" != vidSizer )
    {
        view.width = vidSizer;
    }
    vidSizer = theme.loadpreference( "videoHeight" );

    if( "--" != vidSizer )
    {
        view.height = vidSizer;
    }
}

function saveVidSize(){
    theme.savepreference( "videoWidth", view.width );
    theme.savepreference( "videoHeight", view.height );
	theme.savePreference("vidSnapper" , "false");
	vidZoom.upToolTip = vidSetTip.toolTip;
	mediacenter.videoZoom = 50;
}

function videoZoom(){
	if("false"==theme.loadPreference("vidSnapper")){
		mediacenter.videoZoom = 50;
	}
	if(mediacenter.videoZoom < 76){
		mediacenter.videoZoom = 100;
	}else if(mediacenter.videoZoom <101){
		mediacenter.videoZoom = 150;
	}else if(mediacenter.videoZoom < 156){
		mediacenter.videoZoom = 200;
	}else{
		mediacenter.videoZoom = 75;
	}
	SnapToVideo();
	updateZoomToolTip();
}

function updateZoomToolTip(){

	vidZoom.upToolTip = vidZoomIn.toolTip + mediacenter.videoZoom + vidZoomMid.toolTip;

	if(mediacenter.videoZoom < 76){
		nextZoom = 100;
	}else if(mediacenter.videoZoom <101){
		nextZoom = 150;
	}else if(mediacenter.videoZoom < 156){
		nextZoom = 200;
	}else{
		nextZoom = 75;
	}

	vidZoom.upToolTip += nextZoom + vidZoomOut.toolTip;
	
	if("false"==theme.loadPreference("vidSnapper")){
		vidZoom.upToolTip = vidSetTip.toolTip;
	}
}

function SnapToVideo(){

	theme.savePreference("vidSnapper" , "true");

	var zoom = mediacenter.videoZoom;
	var viewWidth = (player.currentMedia.imageSourceWidth * (zoom/100.00));
	var viewHeight = (player.currentMedia.imageSourceHeight * (zoom/100.00));

	view.width = viewWidth + 28;
	view.height = viewHeight + 147;
}

function checkSnapStatus(){
	if(player.openState!=13) return;
	if("false"==theme.loadPreference("vidSnapper")){
		loadVidSize();
	}else{
		SnapToVideo();
	}
}

function checkVideoPlayerState(){
	if (player){
		switch (player.playState){
			
			case 3: 	//playing
				if(!player.currentMedia.ImageSourceWidth>0){
					theme.savePreference('vidViewer', "false");
					view.close();
					break;
				}
				vidBack.visible = false;
				videoFrame.visible = true;
				if(!player.fullScreen){
					checkSnapStatus();
				}
				break;
			case 8:
				return;
				break;
			}
			vidResize.enabled = true;
			vidZoom.enabled = true;
		}

	if (!player.controls.isAvailable("Stop")) {
		videoFrame.visible = false;
		vidResize.enabled = false;
		vidZoom.enabled = false;
		vidBack.visible = true;
		view.width = 194;
		view.height = 259;
	}
}

function toggleVidDrawer(){
	if(!drawerStatus){
		vidDrawer.moveTo(0,view.height-96,500);
		vidDrawerFrame.visible = true;
		vidDrawerButton.down = true;
		drawerStatus = !drawerStatus;
	}else{
		vidDrawer.moveTo(0,view.height-173,500);
		drawerStatus = !drawerStatus;
	}
}

function checkVidDrawer(){
	drawerStatus = drawerStatus;
	vidDrawerFrame.visible = drawerStatus;
}

function checkVidViewSize(){
	vidBotTile.width = (view.width / 2) + 48;
}


function sliderKey(event,id,val)
{
	switch(event.keyCode){
		case 39:
		case 38: // up
			eval(id + "+=" + val);
			break;
		case 40: // down
		case 37:
			eval(id + "-=" + val);
			break;
	}
}
